# 3.1.3：Index对象

## 将Index看作不可变数组
`Index`对象得许多操作都像数组。可以通过标准`Python`的取值方法获取数值，也可以通过切片获取数值。

```python
In: ind[1] 
Out: 3 
In: ind[::2] 
Out: Int64Index([2, 5, 11], dtype='int64')
```

`Index`对象还有许多与`NumPy`数组相似的属性。

```python
In: print(ind.size, ind.shape, ind.ndim, ind.dtype)
Out: 5 (5,) 1 int64
```
`Index`对象与`NumPy`数组之间的不同在于，`Index`对象的索引是不可变的，也就是说不能通过通常的方式进行调整。
>ind[1] = 0  # 这种操作是不可取的，会报错

## 将Index看作有序集合
`Pandas`对象被设计用于实现许多操作，如连接（`join`）数据集，其中会涉及许多集合操作。`Index `对象遵循`Python`标准库的集合（`set`）数据结构的许多习惯用法，包括并集、交集、差集等。

```python
In: indA = pd.Index([1, 3, 5, 7, 9]) 
In: indB = pd.Index([2, 3, 5, 7, 11]) 
In: indA & indB 	 # 交集
Out: Int64Index([3, 5, 7], dtype='int64') 
In: indA | indB 	 # 并集
Out: Int64Index([1, 2, 3, 5, 7, 9, 11], dtype='int64') 
In: indA ^ indB  	# 异或
Out: Int64Index([1, 2, 9, 11], dtype='int64')
```

这些操作还可以通过调用对象方法来实现，例如 `indA.intersection(indB)`等。





